#include "Appevent.ch"

#include "DXE_CLONE.CH"

PROCEDURE Main
LOCAL nEvent, mp1, mp2, oXbp
LOCAL aDbf := Directory( "*.DBF" )

   IF ! Empty( aDbf )
      AEval( aDbf, {|a| DbUseArea( .T. , , a[1] ) } )

      BuildWorkSpaceTree()

      DO WHILE nEvent <> xbeP_Close
         nEvent := AppEvent( @mp1, @mp2, @oXbp )
         oXbp:handleEvent( nEvent, mp1, mp2 )
      ENDDO
   ENDIF

RETURN

** TreeView erzeugen
PROCEDURE BuildWorkSpaceTree()
LOCAL oTree := XbpTreeView():new( ,, {0,0}, {640,400} )

   oTree:hasLines   := .T.
   oTree:hasButtons := .T.
   oTree:create()

   // Informationen ber jede offene
   // Workarea in den Baum eintragen
   WorkSpaceEval( {|| WorkAreaInfo( oTree ) } )

   oTree:CheckExpandNode()

RETURN

** Baumstruktur fr jede Workarea aufbauen
PROCEDURE WorkAreaInfo( oTree )
LOCAL oArea, oStatus, oStruct

   // Erste Ebene im Baum beginnt bei oTree:rootItem
   oArea := oTree:rootItem:addItem( Alias() )

   // Zweite Ebene im Baum beginnt bei einem TreeViewItem

   // XbpTreeViewItem selbst erzeugen (1. Mglichkeit)
   oStatus         := XbpTreeViewItem():new()
   oStatus:caption := "STATUS"
   oStatus:create()

   oArea:addItem( oStatus )

   // XbpTreeViewItem erzeugen lassen (2. Mglichkeit)
   oStruct := oArea:addItem( "STRUCTURE" )

   // Dritte Ebene im Baum erzeugen
   WAStatus( oStatus )
   WAStruct( oStruct )

RETURN

** Dritte Ebene im Baum -> Statusinformationen
PROCEDURE WAStatus( oItem )
   oItem:addItem( "Bof() = "    + IIf( Bof()  , ".T.", ".F." ) )
   oItem:addItem( "Eof() = "    + IIf( Eof()  , ".T.", ".F." ) )
   oItem:addItem( "Found() = "  + IIf( Found(), ".T.", ".F." ) )
   oItem:addItem( "Recno() = "  + Ltrim( Str( Recno()   ) ) )
   oItem:addItem( "LastRec() =" + Ltrim( Str( LastRec() ) ) )
RETURN

** Dritte Ebene im Baum -> Feldinformationen
PROCEDURE WAStruct( oItem )
   AEval( DbStruct(), ;
     {|a,i,oSub| oSub := oItem:addItem( "FIELD_NAME = " + a[1] ), ;
                 FieldStruct( oSub, a ) } )
RETURN

** Vierte Ebene im Baum erzeugen
PROCEDURE FieldStruct( oItem, aField )
   oItem:addItem( "FIELD_TYPE = " + aField[2] )
   oItem:addItem( "FIELD_LEN  = " + Str( aField[3], 3 ) )
   oItem:addItem( "FIELD_DEC  = " + Str( aField[4], 3 ) )
RETURN
