/*****************************
* Source : IniTree.prg
* System : <unkown>
* Author : Phil Ide
* Created: 28/07/2003
*
* Purpose:
* ----------------------------
* History:
* ----------------------------
*    28/07/2003 15:37 PPI - Created
*****************************/

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "directry.ch"
#include "simpleio.ch"

#pragma Library("XppUI2.lib")

Proc AppSys(); return
Proc DbeSys(); return

Procedure Main(cIni)
   local nEvent
   local mp1
   local mp2
   local oXbp
   local oDlg
   local lExit := FALSE
   local bCancel := {|| lExit := TRUE, oDlg:undo() }
   local bSet    := {|| oDlg:set() }
   local bOk     := {|| lExit := TRUE }

   DEFAULT cIni to SelectIni()

   if !(cIni == NIL)
      if !( "\" $ cIni )
         if FExists(cIni)
            cIni := CurDrive()+':\'+CurDir()+'\'+cIni
         elseif !FExists(GetEnv('windir')+'\'+cIni)
            cIni := NIL
         endif
      endif
   endif
   if !(cIni == NIL)

   SET ALTER TO _LOGFILE.TXT
   SET ALTER ON

      oDlg := IniTreeForm( cIni, bCancel, bOk, bCancel )
      SetAppWindow(oDlg)
      SetAppFocus(oDlg:tv)

      nEvent := xbeP_None
      While !lExit
         nEvent := AppEvent( @mp1, @mp2, @oXbp )
         oXbp:handleEvent( nEvent, mp1, mp2 )
      Enddo
   endif

   SET ALTER OFF
   SET ALTER TO

   return

Function SelectIni()
   local oFOpen := XbpFileDialog():new()
   local cRet

   oFOpen:center := TRUE
   oFOpen:defExtension := "ini"
   oFOpen:fileFilters := {{"Initialisation Files (*.ini)", "*.ini"},{"All Files (*.*)","*.*"}}
   oFOpen:restoreDir := TRUE
   oFOpen:title := "IniEdit - Open File"
   oFOpen:create()

   cRet := oFOpen:open(CurDrive()+':\'+CurDir(),,,FALSE)
   return cRet
