#include "DXE_CLONE.CH" 

///////////////////////////////////////////////////////////////////////////////
//
//  Class code created by the Xbase++ FormDesigner
//    Creation date: 28/07/2003 Creation time: 15:46:15
//
//  Contents  :
//    This file contains the basic structure for the utilization-level of
//    a form. It may (and sould) be modified.
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"

#define CRLF Chr(13)+Chr(10)

Function IniTreeForm(cIni, bClose, bOk, bCancel)
   local oDlg := IniTree():new()
   local bDef := {|| NIL }
   local oIni := TIniFile():new(cIni)
   local aSections := {}
   local i
   local oRoot
   local oItem

   default bClose to bDef,;
           bOk to bDef,;
           bCancel to bDef


   oDlg:close             := bClose
   oDlg:pbOk:activate     := bOk
   oDlg:pbCancel:activate := bCancel

   oDlg:title := cIni

   oDlg:tv:alwaysShowSelection := TRUE
   oDlg:tv:hasButtons          := TRUE
   oDlg:tv:hasLines            := TRUE
   oDlg:tv:itemMarked          := {|oItem,Rect,self| oDlg:upDateControls(oItem) }
   oDlg:sleValue:keyboard      := {|nKey| iif(nKey == xbeK_ENTER .or. nKey == xbeK_RETURN, oDlg:iSetItem(), NIL) }
   oDlg:mleSection:lbClick     := {|aPos,uNil,self| oDlg:mleClick(aPos) }
   oDlg:maxbutton              := FALSE

   oDlg:create()
   oDlg:maxSize                := oDlg:currentSize()
   oDlg:minSize                := oDlg:currentSize()

   oDlg:oIni := oIni

   oDlg:oIni:readSections(aSections)
   oRoot := oDlg:tv:rootItem
   oDlg:tv:lockUpdate(TRUE)
   for i := 1 to len(aSections)
      oItem := XbpTreeViewItem():new()
      oItem:caption := aSections[i]
      oItem:create()
      oItem := oRoot:addItem( oItem )
      oDlg:getItemsFromSection( aSections[i], oItem )
   next
   oDlg:tv:lockUpdate(FALSE)
   oDlg:cArchive := MemoRead(cIni)

   return (oDlg)


******************************************************************************
* This class is derived from the implementation-level class of the form.
* Instance variables are declared in the _IniTree class.
******************************************************************************
CLASS IniTree FROM _IniTree
   EXPORTED:
      VAR oIni
      VAR oCMenu
      VAR cArchive

      METHOD init
      METHOD create
      METHOD getItemsFromSection
      METHOD updateControls
      METHOD set
      METHOD iSetItem
      METHOD mleClick
      METHOD nodeDelete
      METHOD undo
ENDCLASS

******************************************************************************
* Initialize form
******************************************************************************
METHOD IniTree:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   * Execute method of the super class
   ::_IniTree:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::mleSection:editable := FALSE

RETURN self


******************************************************************************
* Request system resources
******************************************************************************
METHOD IniTree:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   * Execute method of the super class
   ::_IniTree:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   // configure and set the context menu
   ::oCMenu := XbpMenu():new(::tv):create()
   ::oCMenu:addItem( {'~Delete'    , {|| ::nodeDelete() }} )

   ::tv:RbDown := {|mp1,mp2,oXbp| ::oCMenu:popUp(oXbp,mp1,2,;
                 XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN  ) }


   * Display the form
   ::show()

RETURN self

METHOD IniTree:getItemsFromSection( cSection, oNode )
   local oItem
   local i
   local aList := {}
   local n
   local cCaption
   local xValue

   ::oIni:readSectionValues( cSection, aList )

   for i := 1 to len(aList)
      n = At('=', aList[i])
      cCaption := Left( aList[i], n-1 )
      xValue   := SubStr( aList[i], n+1 )

      oItem := XbpTreeViewItem():new()
      oItem:caption := cCaption
      oItem:setData( xValue )
      oItem:create()
      oNode:addItem( oItem )
   next
   return self

METHOD IniTree:updateControls( oItem, lMLE )
   local aChild
   local cBuff
   local i

   default lMLE to FALSE

   if !(oItem:getData() == NIL)
      ::sleSection:setData( oItem:getParentItem():caption )
      ::sleKey:setData( oItem:caption )
      ::sleValue:setData( oItem:getdata() )
      if lMLE
         ::updateControls(oItem:getParentItem())
      endif
   else
      aChild := oItem:getChildItems()
      cBuff := '['+oItem:caption+']'+CRLF
      for i := 1 to len(aChild)
         cBuff += aChild[i]:caption+'='+aChild[i]:getData()+CRLF
      next
      ::mleSection:setData(cBuff)
   endif
   return self

METHOD IniTree:set()
   local oItem := ::tv:getData()
   local cSection := oItem:getParentItem():caption
   local cKey     := oItem:caption
   local xValue   := oItem:getData()
   local cValue   := AllTrim(::sleValue:getData())

   ::oIni:writeString( cSection, cKey, cValue )
   oItem:setData( cValue )
   ::updateControls( oItem:getparentItem() )
   return self

METHOD IniTree:iSetItem()
   ::set()
   SetAppFocus(::tv)
   return self

METHOD IniTree:mleClick( aPos )
   local c := ::mleSection:getData()
   local n := ::mleSection:charFromLine()
   local i := At(CRLF,c,n)
   local cSection := SubStr( c, 2, AT(']',c)-2 )
   local oItem
   local aChild

   n := iif( n == 0, Len(c), n )
   c := SubStr( c, n, i-n )
   c := left(c,At('=',c)-1)

   oItem := ::tv:rootItem
   ::tv:lockUpdate(TRUE)
   aChild := oItem:getChildItems()
   for i := 1 to len(aChild)
      if aChild[i]:caption == cSection
         oItem := aChild[i]
         aChild := oItem:getChildItems()
         for n := 1 to len(aChild)
            if aChild[n]:caption == c
               ::tv:setData( aChild[n] )
               i := Len(aChild)+1
               exit
            endif
         next
      endif
   next
   ::tv:lockUpdate(FALSE)
   return self

METHOD IniTree:nodeDelete()
   local oNode := ::tv:getData()
   local lOk   := FALSE
   local cSection
   local cKey
   local oParent

   if oNode:getData() == NIL // section!
      cSection := oNode:caption
      if ConfirmBox(,'Delete complete section'+CRLF+CRLF+'['+cSection+']'+CRLF+CRLF+;
                    'Are You Sure?','Delete Section',,;
                    XBPMB_WARNING+XBPMB_APPMODAL) == XBPMB_RET_OK
         ::oIni:eraseSection(cSection)
         lOk := TRUE
      endif
   else
      cKey := oNode:caption
      cSection := oNode:getParentItem():caption
      if ConfirmBox(,'Delete key'+CRLF+CRLF+'['+cSection+']:'+cKey+CRLF+CRLF+;
                    'Are You Sure?','Delete Key',,;
                    XBPMB_WARNING+XBPMB_APPMODAL) == XBPMB_RET_OK
         ::oIni:deleteKey(cSection, cKey)
         lOk := TRUE
      endif
   endif
   if lOk
      ::tv:lockUpdate(TRUE)
      oParent := oNode:getparentItem()
      oParent:delItem(oNode)
      ::updateControls(::tv:getData(), TRUE)
      ::tv:lockUpdate(FALSE)
   endif
   return self

METHOD IniTree:undo()
   local nH := FCreate(::oIni:fileName)

   if nH > 0
      FWrite(nH, ::cArchive)
      FClose(nH)
   endif
   return self






* Include program code for the implementation-level class of the form
#include "_INITREEFORM.PRG"

//EOF
/////